%{
/* Versão para criar uma base de dados de pessoas 
 * TPC : Tabela SQL
 * Chave (not null) | Nome (not null) | Apelido (not null) | Genero (null)
 */

// mais simbolos terminais: , . : ( ) { } 

#include <stdlib.h>
#include <stdio.h>
#include "parser.h"

extern int yylineno;
int chave=1;
char* apeMae;
char* apePai;
%}

%union{
  char* str;
  int gen;
  int num;
  prog* prg;
}

%token NUM MASC FEM STR ERRO

%type <str> Nome Apelido Filho STR
%type <gen> Genero MASC FEM
%type <num> AnoCasamento NUM
%type <prg> Progenitor

%start Genea
%%
Genea: Familias {}
      ;

Familias: Familias Familia {}
        | Familia {}
        ;

Familia: Pais Filhos {}
        ;

Pais: '(' Progenitor ',' Progenitor ':' AnoCasamento ')' {if(apePai){
                                                            free(apePai);apePai=NULL;
                                                          }
                                                          if(apeMae){
                                                            free(apeMae);apeMae=NULL;
                                                          }
                                                          if($2)
                                                            if($2->gen==0)
                                                              apePai=$2->apelido;
                                                            else
                                                              apeMae=$2->apelido;
                                                          if($4)
                                                            if($4->gen==0)
                                                              apePai=$4->apelido;
                                                            else
                                                              apeMae=$4->apelido;
                                                         }
    ;
    
AnoCasamento: NUM {}
            ;
    
Progenitor: Nome Apelido Genero { 
      printf("insert into pessoas (Chave,Nome,Apelido,Genero) values (%d,'%s','%s',%d);\n",chave++,$1,$2,$3);
      $$=(Prog)malloc(sizeof(prog));
      $$->gen=$3;
      $$->apelido=$2;}
          | {$$=NULL;}
          ;

Genero: MASC {$$=0;}
      | FEM {$$=1;}
      ;

Nome: STR {$$=$1;}
    ;

Apelido: STR {$$=$1;}
        ;
    
Filhos: '{' Lista '}' {}
      ;

Lista: ListaFilhos {}
      | {}
      ;

ListaFilhos: ListaFilhos ',' Filho {
        if(apeMae&&apePai){
          printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','%s %s');\n",chave++,$3,apeMae,apePai);
        } 
        else{
          if(apeMae){
            printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','%s');\n",chave++,$3,apeMae);
          }
          else{
            if(apePai){
              printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','%s');\n",chave++,$3,apePai);
            }
            else{
              printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','incognito');\n",chave++,$3);
            }
          }
        }
      }
            | Filho { 
              if(apePai&&apeMae)
                printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','%s %s');\n",chave++,$1,apeMae,apePai);
              else  if(apeMae)
                printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','%s');\n",chave++,$1,apeMae);
              else  if(apePai)
                printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','%s');\n",chave++,$1,apePai);
              else
                printf("insert into pessoas (Chave,Nome,Apelido) values (%d,'%s','incognito');\n",chave++,$1);
              }
            ;

Filho: Nome {$$=$1;}
    ;
    
%%
int main(){yyparse();return 0;}
int yyerror(char* s){printf("ERRO: linha %d: %s\n",yylineno,s);return 2;}